#define CLEAR_HUB_FEATURE	0x20
#define CLEAR_PORT_FEATURE	0x23
#define GET_BUS_STATE		0xa3
#define GET_HUB_DESCRIPTOR	0xa0
#define GET_HUB_STATUS		0xa0
#define GET_PORT_STATUS		0xa3
#define SET_HUB_DESCRIPTOR	0x20
#define SET_HUB_FEATURE		0x20
#define SET_PORT_FEATURE	0x23

//////Hub Class Feature Selectors
#define	C_HUB_LOCAL_POWER	0
#define C_HUB_OVER_CURRENT	1
#define PORT_CONNECTION		0
#define PORT_ENABLE			1
#define PORT_SUSPEND		2
#define PORT_OVER_CURRENT	3
#define PORT_RESET			4
#define PORT_POWER			8
#define	PORT_LOW_SPEED		9
#define C_PORT_CONNECTION	16
#define C_PORT_ENABLE		17
#define C_PORT_SUSPEND		18
#define C_PORT_OVER_CURRENT	19
#define C_PORT_RESET		20

////////Hub Class Request Codes
#define GET_STATUS			0
#define CLEAR_FEATURE		1
#define GET_STATE			2
#define SET_FEATURE			3
#define GET_DESCRIPTOR		6
#define SET_DESCRIPTOR		7

typedef struct _HUB_DESCRIPTOR
{
	unsigned char bDescLength;
	unsigned char bDescriptorType;
	unsigned char bNbrPorts;
	unsigned char wHubCharacteristics[2];
	unsigned char bPwrOn2PwrGood;
	unsigned char bHubContrCurrent;
	unsigned char DeviceRemovable;
	
}
HUBDescr,*PHUBDescr;

/////////// ̬Ϣ
typedef struct _INF
{
	unsigned char bAddr; // 豸ĵַ
	unsigned char bDevType; // 豸HUBǹ豸
	unsigned char bUpPort; // һ˿ڵַ,0xff˿
	unsigned char bEndpSize; // ˵0С
	
	union _KUNO
	{
		struct _HUB
		{
			unsigned char bNumPort; // ˿
			unsigned char bHUBendp; // ж϶˵ַ
			unsigned char bInterval; // жϼʱ
			unsigned char bSlavePort[7]; // ˿ڵĵַ,Ĭϼ7˿
		}
		HUB; // 

		struct _DEV
		{
			unsigned char bSpeed; // 豸ٶȣȫٻǵ
			// ʣౣɷù豸

		}
		DEV; // 豸
	}
	KUNO; // ,豸Թ
}
INF, *PINF; // 豸Ϣ

typedef struct _NUM
{
	//INF Num[127]; // 127豸
	INF Num[50]; // 127豸
}
NUM, *PNUM;

// Լı
#define	HUB_TYPE		0x66
#define FUNCTION_DEV	0x77
#define	FULL_SPEED		0x88
#define LOW_SPEED		0x99
#define FIND_ATTACH		0xaa
#define FIND_REMOVE		0xbb
